Edit

Published - List Datasource Elements

Returns schema elements at a level of the schema tree for a published datasource.

Note

Data Agent configuration management is currently in Preview (learn more).

Elements represent the schema tree of a datasource (schemas, tables, columns). Navigate level-by-level using the rootId parameter.

This API supports pagination.

Permissions

The caller must have read permissions for the DataAgent.

Required Delegated Scopes

Item.Read.All or Item.ReadWrite.All or DataAgent.Read.All or DataAgent.ReadWrite.All

Microsoft Entra supported identities

This API supports the Microsoft identities listed in this section.

Identity Support
User Yes
Service principal and Managed identities Yes

Interface

GET https://api.fabric.microsoft.com/v1/workspaces/{workspaceId}/dataAgents/{dataAgentId}/datasources/{datasourceId}/elements
GET https://api.fabric.microsoft.com/v1/workspaces/{workspaceId}/dataAgents/{dataAgentId}/datasources/{datasourceId}/elements?rootId={rootId}&continuationToken={continuationToken}

URI Parameters

Name In Required Type Description
dataAgentId
path True

string (uuid)

The DataAgent ID.

datasourceId
path True

string (uuid)

The datasource ID.

workspaceId
path True

string (uuid)

The workspace ID.

continuationToken
query

string

A token for retrieving the next page of results.

rootId
query

string

The identifier of a parent element. Omit to get the root level.

Responses

Name Type Description
200 OK

DataSourceElements

Request completed successfully.

429 Too Many Requests

ErrorResponse

The service rate limit was exceeded. The server returns a Retry-After header indicating, in seconds, how long the client must wait before sending additional requests.

Headers

Retry-After: integer

Other Status Codes

ErrorResponse

Common error codes:

  • ItemNotFound - The requested item was not found.

Examples

List published DataAgent datasource elements example

Sample request

GET https://api.fabric.microsoft.com/v1/workspaces/f089354e-8366-4e18-aea3-4cb4a3a50b48/dataAgents/41ce06d1-d81b-4ea0-bc6d-2ce3dd2f8e87/datasources/c1c6d12f-8d2a-4d5b-9ca1-8bb7b42d4a30/elements

Sample response

{
  "value": [
    {
      "id": "U2NoZW1hcw==",
      "isSelected": false,
      "displayName": "Schemas",
      "type": "Schemas",
      "hasSubElements": true,
      "state": "Available",
      "lastSyncDateTime": "2025-06-15T10:30:00Z"
    },
    {
      "id": "VGFibGVz",
      "isSelected": false,
      "displayName": "Tables",
      "type": "Tables",
      "hasSubElements": true,
      "state": "Available",
      "lastSyncDateTime": "2025-06-15T10:30:00Z"
    }
  ],
  "continuationToken": null,
  "continuationUri": null
}

Definitions

Name Description
DataSourceElement

A datasource schema element.

DataSourceElements

A paginated list of datasource schema elements.

ElementState

Indicates the current availability of the element in the datasource schema. Additional ElementState types may be added over time.

ElementType

The public type of a datasource schema element. Additional ElementType types may be added over time.

ErrorRelatedResource

The error related resource details object.

ErrorResponse

The error response.

ErrorResponseDetails

The error response details.

IndexState

Index state for lakehouse file directories. Additional IndexState types may be added over time.

DataSourceElement

A datasource schema element.

Name Type Description
dataType

string

Data type for columns (e.g., int, string). Present only for column elements.

description

string

User-set description of the element.

displayName

string

Human-readable name of the element.

hasSubElements

boolean

Whether this element has children to drill into.

id

string

The element identifier. Use as rootId to drill deeper into the schema tree.

indexState

IndexState

Index state for lakehouse file directories.

isSelected

boolean

Whether this element is selected for use by the DataAgent.

lastSyncDateTime

string

The last time this element was synchronized from the datasource schema, as an ISO 8601 timestamp (e.g., 2025-06-15T10:30:00Z).

state

ElementState

Indicates if the element exists in the live schema.

type

ElementType

The type of schema element.

DataSourceElements

A paginated list of datasource schema elements.

Name Type Description
continuationToken

string

The token for the next result set batch. If there are no more records, it's removed from the response.

continuationUri

string

The URI of the next result set batch. If there are no more records, it's removed from the response.

value

DataSourceElement[]

A list of schema elements.

ElementState

Indicates the current availability of the element in the datasource schema. Additional ElementState types may be added over time.

Value Description
Available

The element is available in the datasource schema.

NotAvailable

The element was previously configured but is no longer available in the datasource schema.

AccessDenied

The datasource schema could not be read because access was denied.

AccessDeniedOap

The datasource schema could not be read because access is blocked by an organizational access policy.

DatasourceNotFound

The datasource could not be found.

SchemaUnavailable

The datasource schema is currently unavailable.

ElementType

The public type of a datasource schema element. Additional ElementType types may be added over time.

Value Description
Root

The root element of a datasource schema tree.

Files

A files container element.

Directory

A directory element.

Schemas

A grouping container for schema elements.

Tables

A grouping container for table elements.

Views

A grouping container for view elements.

Functions

A grouping container for function elements.

ScalarFunctions

A grouping container for scalar function elements.

TableValuedFunctions

A grouping container for table-valued function elements.

Shortcuts

A grouping container for shortcut elements.

MaterializedViews

A grouping container for materialized view elements.

Schema

A schema element.

Table

A table element.

ExternalTable

An external table element.

MaterializedView

A materialized view element.

View

A view element.

Column

A column element.

Measure

A measure element.

Function

A function element.

FunctionParameter

A function parameter element.

FunctionReturnValue

A function return value element.

NodeType

A graph node type element.

EdgeType

A graph edge type element.

Entity

An ontology entity element.

ErrorRelatedResource

The error related resource details object.

Name Type Description
resourceId

string

The resource ID that's involved in the error.

resourceType

string

The type of the resource that's involved in the error.

ErrorResponse

The error response.

Name Type Description
errorCode

string

A specific identifier that provides information about an error condition, allowing for standardized communication between our service and its users.

isRetriable

boolean

When true, the request can be retried. Use the Retry-After response header to determine the delay, if available.

message

string

A human readable representation of the error.

moreDetails

ErrorResponseDetails[]

List of additional error details.

relatedResource

ErrorRelatedResource

The error related resource details.

requestId

string (uuid)

ID of the request associated with the error.

ErrorResponseDetails

The error response details.

Name Type Description
errorCode

string

A specific identifier that provides information about an error condition, allowing for standardized communication between our service and its users.

message

string

A human readable representation of the error.

relatedResource

ErrorRelatedResource

The error related resource details.

IndexState

Index state for lakehouse file directories. Additional IndexState types may be added over time.

Value Description
Indexed

Directory has been indexed for unstructured search.

Indexing

Directory is currently being indexed.

NotIndexed

Directory has not been indexed.